<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>article (5)</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
    <style type="text/css">
      a.sourceLine {
        display: inline-block;
        line-height: 1.25;
      }
      a.sourceLine {
        pointer-events: none;
        color: inherit;
        text-decoration: inherit;
      }
      a.sourceLine:empty {
        height: 1.2em;
      }
      .sourceCode {
        overflow: visible;
      }
      code.sourceCode {
        white-space: pre;
        position: relative;
      }
      div.sourceCode {
        margin: 1em 0;
      }
      pre.sourceCode {
        margin: 0;
      }
      @media screen {
        div.sourceCode {
          overflow: auto;
        }
      }
      @media print {
        code.sourceCode {
          white-space: pre-wrap;
        }
        a.sourceLine {
          text-indent: -1em;
          padding-left: 1em;
        }
      }
      pre.numberSource a.sourceLine {
        position: relative;
        left: -4em;
      }
      pre.numberSource a.sourceLine::before {
        content: attr(title);
        position: relative;
        left: -1em;
        text-align: right;
        vertical-align: baseline;
        border: none;
        pointer-events: all;
        display: inline-block;
        -webkit-touch-callout: none;
        -webkit-user-select: none;
        -khtml-user-select: none;
        -moz-user-select: none;
        -ms-user-select: none;
        user-select: none;
        padding: 0 4px;
        width: 4em;
        color: #aaaaaa;
      }
      pre.numberSource {
        margin-left: 3em;
        border-left: 1px solid #aaaaaa;
        padding-left: 4px;
      }
      div.sourceCode {
      }
      @media screen {
        a.sourceLine::before {
          text-decoration: underline;
        }
      }
      code span.al {
        color: #ff0000;
        font-weight: bold;
      } /* Alert */
      code span.an {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Annotation */
      code span.at {
        color: #7d9029;
      } /* Attribute */
      code span.bn {
        color: #40a070;
      } /* BaseN */
      code span.bu {
      } /* BuiltIn */
      code span.cf {
        color: #007020;
        font-weight: bold;
      } /* ControlFlow */
      code span.ch {
        color: #4070a0;
      } /* Char */
      code span.cn {
        color: #880000;
      } /* Constant */
      code span.co {
        color: #60a0b0;
        font-style: italic;
      } /* Comment */
      code span.cv {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* CommentVar */
      code span.do {
        color: #ba2121;
        font-style: italic;
      } /* Documentation */
      code span.dt {
        color: #902000;
      } /* DataType */
      code span.dv {
        color: #40a070;
      } /* DecVal */
      code span.er {
        color: #ff0000;
        font-weight: bold;
      } /* Error */
      code span.ex {
      } /* Extension */
      code span.fl {
        color: #40a070;
      } /* Float */
      code span.fu {
        color: #06287e;
      } /* Function */
      code span.im {
      } /* Import */
      code span.in {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Information */
      code span.kw {
        color: #007020;
        font-weight: bold;
      } /* Keyword */
      code span.op {
        color: #666666;
      } /* Operator */
      code span.ot {
        color: #007020;
      } /* Other */
      code span.pp {
        color: #bc7a00;
      } /* Preprocessor */
      code span.sc {
        color: #4070a0;
      } /* SpecialChar */
      code span.ss {
        color: #bb6688;
      } /* SpecialString */
      code span.st {
        color: #4070a0;
      } /* String */
      code span.va {
        color: #19177c;
      } /* Variable */
      code span.vs {
        color: #4070a0;
      } /* VerbatimString */
      code span.wa {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Warning */
    </style>
  </head>
  <body>
    <h1 id="hello-world">Hello, world!</h1>
    <p>
      This part of the tutorial is about core JavaScript, the language itself.
    </p>
    <p>
      But we need a working environment to run our scripts and, since this book
      is online, the browser is a good choice. We’ll keep the amount of
      browser-specific commands (like <code>alert</code>) to a minimum so that
      you don’t spend time on them if you plan to concentrate on another
      environment (like Node.js). We’ll focus on JavaScript in the browser in
      the <a href="/ui">next part</a> of the tutorial.
    </p>
    <p>
      So first, let’s see how we attach a script to a webpage. For server-side
      environments (like Node.js), you can execute the script with a command
      like <code>"node my.js"</code>.
    </p>
    <h2 id="the-script-tag">The “script” tag</h2>
    <p>
      JavaScript programs can be inserted almost anywhere into an HTML document
      using the <code>&lt;script&gt;</code> tag.
    </p>
    <p>For instance:</p>
    ```html run height=100 &lt;!DOCTYPE html&gt;
    <html>
      <body>
        <p>Before the script…</p>
        <em>!</em>
        <script>
          alert("Hello, world!");
        </script>
        <p><em>/!</em></p>
        <p>…After the script.</p>
      </body>
    </html>
    <p>```</p>
    <pre
      class="online"
    ><code>You can run the example by clicking the &quot;Play&quot; button in the right-top corner of the box above.</code></pre>
    <p>
      The <code>&lt;script&gt;</code> tag contains JavaScript code which is
      automatically executed when the browser processes the tag.
    </p>
    <h2 id="modern-markup">Modern markup</h2>
    <p>
      The <code>&lt;script&gt;</code> tag has a few attributes that are rarely
      used nowadays but can still be found in old code:
    </p>
    <dl>
      <dt>
        The <code>type</code> attribute:
        <code>&lt;script <u>type</u>=…&gt;</code>
      </dt>
      <dd>
        The old HTML standard, HTML4, required a script to have a
        <code>type</code>. Usually it was <code>type="text/javascript"</code>.
        It’s not required anymore. Also, the modern HTML standard totally
        changed the meaning of this attribute. Now, it can be used for
        JavaScript modules. But that’s an advanced topic, we’ll talk about
        modules in another part of the tutorial.
      </dd>
      <dt>
        The <code>language</code> attribute:
        <code>&lt;script <u>language</u>=…&gt;</code>
      </dt>
      <dd>
        This attribute was meant to show the language of the script. This
        attribute no longer makes sense because JavaScript is the default
        language. There is no need to use it.
      </dd>
      <dt>Comments before and after scripts.</dt>
      <dd>
        <p>
          In really ancient books and guides, you may find comments inside
          <code>&lt;script&gt;</code> tags, like this:
        </p>
        <p>
          <code
            >html no-beautify &lt;script type="text/javascript"&gt;&lt;!-- ...
            //--&gt;&lt;/script&gt;</code
          >
        </p>
        <p>
          This trick isn’t used in modern JavaScript. These comments hide
          JavaScript code from old browsers that didn’t know how to process the
          <code>&lt;script&gt;</code> tag. Since browsers released in the last
          15 years don’t have this issue, this kind of comment can help you
          identify really old code.
        </p>
      </dd>
    </dl>
    <h2 id="external-scripts">External scripts</h2>
    <p>
      If we have a lot of JavaScript code, we can put it into a separate file.
    </p>
    <p>
      Script files are attached to HTML with the <code>src</code> attribute:
    </p>
    <div class="sourceCode" id="cb2">
      <pre
        class="sourceCode html"
      ><code class="sourceCode html"><a class="sourceLine" id="cb2-1" title="1"><span class="kw">&lt;script</span><span class="ot"> src=</span><span class="st">&quot;/path/to/script.js&quot;</span><span class="kw">&gt;&lt;/script&gt;</span></a></code></pre>
    </div>
    <p>
      Here, <code>/path/to/script.js</code> is an absolute path to the script
      from the site root. One can also provide a relative path from the current
      page. For instance, <code>src="script.js"</code> would mean a file
      <code>"script.js"</code> in the current folder.
    </p>
    <p>We can give a full URL as well. For instance:</p>
    <div class="sourceCode" id="cb3">
      <pre
        class="sourceCode html"
      ><code class="sourceCode html"><a class="sourceLine" id="cb3-1" title="1"><span class="kw">&lt;script</span><span class="ot"> src=</span><span class="st">&quot;https://cdnjs.cloudflare.com/ajax/libs/lodash.js/4.17.11/lodash.js&quot;</span><span class="kw">&gt;&lt;/script&gt;</span></a></code></pre>
    </div>
    <p>To attach several scripts, use multiple tags:</p>
    <div class="sourceCode" id="cb4">
      <pre
        class="sourceCode html"
      ><code class="sourceCode html"><a class="sourceLine" id="cb4-1" title="1"><span class="kw">&lt;script</span><span class="ot"> src=</span><span class="st">&quot;/js/script1.js&quot;</span><span class="kw">&gt;&lt;/script&gt;</span></a>
<a class="sourceLine" id="cb4-2" title="2"><span class="kw">&lt;script</span><span class="ot"> src=</span><span class="st">&quot;/js/script2.js&quot;</span><span class="kw">&gt;&lt;/script&gt;</span></a>
<a class="sourceLine" id="cb4-3" title="3">…</a></code></pre>
    </div>
    <pre
      class="smart"
    ><code>As a rule, only the simplest scripts are put into HTML. More complex ones reside in separate files.

The benefit of a separate file is that the browser will download it and store it in its [cache](https://en.wikipedia.org/wiki/Web_cache).

Other pages that reference the same script will take it from the cache instead of downloading it, so the file is actually downloaded only once.

That reduces traffic and makes pages faster.</code></pre>
    ```<code>warn header="If</code>src<code
      >is set, the script content is ignored." A single</code
    >
    <script>
      `tag can't have both the`src` attribute and code inside.

      This won't work:

      ```html
      <script *!*src*/!*="file.js">
        alert(1); // the content is ignored, because src is set
    </script>
    <p>```</p>
    <p>
      We must choose either an external <code>&lt;script src="…"&gt;</code> or a
      regular <code>&lt;script&gt;</code> with code.
    </p>
    <p>The example above can be split into two scripts to work:</p>
    <div class="sourceCode" id="cb6">
      <pre
        class="sourceCode html"
      ><code class="sourceCode html"><a class="sourceLine" id="cb6-1" title="1"><span class="kw">&lt;script</span><span class="ot"> src=</span><span class="st">&quot;file.js&quot;</span><span class="kw">&gt;&lt;/script&gt;</span></a>
<a class="sourceLine" id="cb6-2" title="2"><span class="kw">&lt;script&gt;</span></a>
<a class="sourceLine" id="cb6-3" title="3">  <span class="at">alert</span>(<span class="dv">1</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb6-4" title="4"><span class="kw">&lt;/script&gt;</span></a></code></pre>
    </div>
    <pre><code>
## Summary

- We can use a `&lt;script&gt;` tag to add JavaScript code to a page.
- The `type` and `language` attributes are not required.
- A script in an external file can be inserted with `&lt;script src=&quot;path/to/script.js&quot;&gt;&lt;/script&gt;`.


There is much more to learn about browser scripts and their interaction with the webpage. But let&#39;s keep in mind that this part of the tutorial is devoted to the JavaScript language, so we shouldn&#39;t distract ourselves with browser-specific implementations of it. We&#39;ll be using the browser as a way to run JavaScript, which is very convenient for online reading, but only one of many.</code></pre>
  </body>
</html>
